module(..., package.seeall)
local scheme = require'scheme'
local readpopen = scheme.readpopen

local version = readpopen("{ cat /version 2>/dev/null || date; } | sed  -r 's/[^[:alnum:]._-]+//g' | tr -d '\\n'") or tostring(math.random())

local localeString = function(h,l)
                        return scheme.localeString("conf_"..h, l):gsub("^conf_","")
                     end

--[[
_H = "conf_RemoveStoredEtctargz",
_H = "conf_RebootWithNewEtc",
_H = "conf_FullDeviceConfigEtcForOneToOneCopyingAndRestoring",
_H = "conf_GetGzipedEtc",
_H = "conf_LoadNewEtcToDevice",
_H = "conf_BasicDevConfNsgconfigWithoutPwdCertModAppStandaloneFiles",
_H = "conf_GetEtcnsgconfig",
_H = "conf_SaveToEtcnsgconfig",
_H = "conf_ErrorLoadedFileIsNotGoodOrNoMemory",
_H = "conf_NewEtcSavedButNotApplyedRebootDeviceToApplyNewEtc",
_H = "conf_ErrorLoadedFileIsNotGood",
_H = "conf_ConfigurationSaved",
_H = "conf_ErrorCantOpenFileEtcnsgconfigForWriting",
--]]

replaceNil = function (a, ...)
                   if(#{...} == 0) then
                      return a
                   else
                      return (a or ""), replaceNil(...)
                   end
                end

local fstr = function (...)
             return table.concat({replaceNil(...)})
          end

local calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or ''
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
                  local res, value = pcall(loadstring('setfenv(1, {})return '..valString))
                  if not res or value == nil then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
            end

local urlDecode = function(s)
                     return (string.gsub (string.gsub (tostring(s or ""), "+", " "),
                                          "%%(%x%x)",
                                          function (str)
                                             return string.char (tonumber (str, 16))
                                          end )
                          )
                  end

local htmlEncode =function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                              "\"",
                                                              "&quot;"),
                                                 "<",
                                                 "&lt;"),
                                    ">",
                                    "&gt;")
             end

local confToTable =
   function(str)
      local confTable, res
      local func, err =
         (function ()
             local str = str
             local loadstring = loadstring
             setfenv(1, {})
             return loadstring(str)
         end)()
      if not func then
         return {_err = err or "Unknown error"}
      end
      res, confTable = pcall(func)
      return confTable or {}
   end

_L = {
   start = function (htmlEnv)
              local formParams = fstr(
                 '<INPUT type=hidden name="command" value="getHTML">',
                 '<INPUT type=hidden name="login" value="',htmlEncode(htmlEnv.data.login),'">',
                 '<INPUT type=hidden name="path" value="',htmlEncode(htmlEnv.data.path),'">',
                 '<INPUT type=hidden name="pass" value="',htmlEncode(htmlEnv.data.pass),'">',
                 '<INPUT type=hidden name="locale" value="',htmlEncode(htmlEnv.data.locale),'">',
                 '<INPUT type=hidden name="module" value="',htmlEncode(htmlEnv.data.module),'">'
              )
              local etc = ""
              if 0 == os.execute("[ -f /etc/newetc.tar.gz ]") then
                 etc =  fstr('<form method="POST" enctype="multipart/form-data" target="_self">',
                             formParams,
                             '<INPUT type=hidden name="subcmd"  value="rmetc">',
                             '<input type="submit" name="go"  value="',localeString("RemoveStoredEtctargz", htmlEnv.data.locale),'">',
                             '</form>',
                             '<form method="POST" enctype="multipart/form-data" target="_self">',
                             formParams,
                             '<INPUT type=hidden name="subcmd"  value="reboot">',
                             '<input type="submit" name="go"  value="',localeString('RebootWithNewEtc', htmlEnv.data.locale),'">',
                             '</form>'
                          )
              end
              return true, fstr([[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
                                <html>
                                <head>
                                <title>NSG Configurations Management</title>
                                <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
                                <script src="/jquery.js" type="text/javascript" ></script> 
                                <script src="/tinysort.js" type="text/javascript" ></script>
                                <link rel="stylesheet" type="text/css" href="/style.css">
                                <link rel="icon" type="image/x-icon" href="/nsg.ico">
                                <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico">
                                </head>]],
                       "<script type=\"text/javascript\">var NSGVERSION=\"",version:gsub("[^%w]*",""),"\";var PATH=",
                       ("%q"):format(htmlEnv.data.path),
                       ";var LOGIN=\"",
                       htmlEnv.data.login,
                       "\";var PASS=\"",
                       htmlEnv.data.pass,
                       "\";\nvar MODULE=\"",
                       htmlEnv.data.module,
                       "\";var AUTH=\"login=\"+LOGIN+\"&module=\"+MODULE+ \"&pass=\" + PASS +\"&path=\" + PATH + \"&\";var PAGENAME=\""..htmlEnv.data.pagename.."\";var LOCALE=\"",
                       locale,"\";var CONTENT=\"\";var TIMER=null; var REQUEST=null;</script>",
                       "<script src=\"/nsghelp.js\" type=\"text/javascript\" ></script>",
                       "<script src=\"/script.js\" type=\"text/javascript\" ></script>",
                       "<body style=\"text-align:center;\">",
                       "<div class=\"welcome\">NSG Configurations Management</div>",
                       htmlEnv.banner and "<br><b>"..htmlEnv.banner..'</b></br>'  or "",
                       "<p><center><h>",localeString("FullDeviceConfigEtcForOneToOneCopyingAndRestoring", htmlEnv.data.locale),":</h>",
                        '<form method="POST" enctype="multipart/form-data" target="_blank">',
                       formParams,
                       '<INPUT type=hidden name="subcmd"  value="exportetc">',
                       '<input type="submit" name="go"  value="',localeString("GetGzipedEtc", htmlEnv.data.locale),'">',
                       '</form>',
                       '<form method="POST" enctype="multipart/form-data" target="_self">',
                       formParams,
                       '<INPUT type=hidden name="MAX_FILE_SIZE" value=3000000>',
                       '<INPUT type=hidden name="subcmd"  value="importetc">',
                       '<input type="file" name="file" size="70"><br />',
                       '<input type="submit" name="go"  value="',localeString("LoadNewEtcToDevice", htmlEnv.data.locale),'">',
                       '</form>',
                       etc,
                       "</center></p>",
                       '<p><center><h>',localeString("BasicDevConfNsgconfigWithoutPwdCertModAppStandaloneFiles", htmlEnv.data.locale),':</h>',
                       '<form method="POST" enctype="multipart/form-data" target="_blank">',
                       formParams,
                       '<INPUT type=hidden name="subcmd"  value="exportconfig">',
                       '<input type="submit" name="go"  value="', localeString("GetEtcnsgconfig", htmlEnv.data.locale),'">',
                       '</form>',
                       '<form method="POST" enctype="multipart/form-data" target="_self">',
                       formParams,
                       '<INPUT type=hidden name="MAX_FILE_SIZE" value=500000>',
                       '<INPUT type=hidden name="subcmd"  value="importconfig">',
                       '<input type="file" name="file" size="70"><br />',
                       '<input type="submit" name="go"  value="', localeString("SaveToEtcnsgconfig", htmlEnv.data.locale),'">',
                       '</form>',
                       '</center></p>',
                       '</body></html>'
                    )
            end,
   importetc = function (htmlEnv)
                  local buf="XX"
                  local fname = os.tmpname()
                  local f=io.open(fname,"w")
                  while type(buf)=='string' and #buf>0 do
                     buf = htmlEnv.data.file.file:read(1024*1024)
                     f:write(buf or "")
                  end
                  f:close()
                  if 0 ~= os.execute("tar tz -f "..fname.." | grep '/nsg/[.]release'  && mv -f "..fname.." /etc/newetc.tar.gz") then
                     htmlEnv.banner = "<font color=\"red\">"..localeString("ErrorLoadedFileIsNotGoodOrNoMemory", htmlEnv.data.locale).."</font>"
                  else
                     htmlEnv.banner = "<font color=\"green\">"..localeString("NewEtcSavedButNotApplyedRebootDeviceToApplyNewEtc", htmlEnv.data.locale).."</font>"
                  end
                  os.execute("rm -f "..fname)
                  return _L.start(htmlEnv)
               end,
   exportetc = function (htmlEnv)
               local f = io.popen("/bin/tar  -C /etc -c . | /bin/gzip", "r")
               local buf = f:read("*a")
               f:close()
               htmlEnv:headPrint("Accept-Ranges","bytes")
               htmlEnv:headPrint("Content-Length",#buf)
               htmlEnv:headPrint("Content-Type", "application/x-gzip")
               htmlEnv:headPrint("Content-Disposition",'form-data; name="AttachedFile"; filename="etc.'..((readpopen("hostname") or "").."-"..(readpopen("date '+%Y%m%d-%H%M%S'") or "")):gsub("[^%w%.%-%_]+","")..'.tar.gz"')
               return true, buf or ""
            end,
   exportconfig = function (htmlEnv)
               local f = io.popen("/bin/cat /etc/nsgconfig", "r")
               local buf = f:read("*a")
               f:close()
               buf = "return "..nsg.serialize(confToTable(buf), 1)
               htmlEnv:headPrint("Accept-Ranges","bytes")
               htmlEnv:headPrint("Content-Length",#buf)
               htmlEnv:headPrint("Content-Type", "text/plain")
               htmlEnv:headPrint("Content-Disposition",'form-data; name="AttachedFile"; filename="nsgconfig.'..((readpopen("hostname") or "").."-"..(readpopen("date '+%Y%m%d-%H%M%S'") or "")):gsub("[^%w%.%-%_]+","")..'.txt"')

               return true, buf or ""
            end,

   importconfig = function (htmlEnv)
                     local nsg = require"nsg"
                     local buf = htmlEnv.data.file.file:read("*a")
                     local res = confToTable(buf)

                     if res["_err"] then
                        htmlEnv.banner = "<font color=\"red\">"..localeString("ErrorLoadedFileIsNotGood", htmlEnv.data.locale).."<br/>"..htmlEncode(res["_err"]).."</font>"
                        return _L.start(htmlEnv)
                     else
                        local f = io.open("/etc/nsgconfig","w")
                        if f then
                           f:write("return"..nsg.serialize(res))
                           f:close()
                           htmlEnv.banner = "<font color=\"green\">"..localeString("ConfigurationSaved", htmlEnv.data.locale).."</font><br><div style=\"align=left;\"><pre>"..htmlEncode(nsg.serialize(res, 1)).."</pre></div>"
                        else
                           htmlEnv.banner = "<font color=\"red\"><font color=\"red\">"..localeString("ErrorCantOpenFileEtcnsgconfigForWriting", htmlEnv.data.locale).."</font>"
                        end
                        return _L.start(htmlEnv)
                     end
                  end,

   rmetc = function (htmlEnv)
              os.execute("rm -f /etc/newetc.tar.gz")
              return _L.start(htmlEnv)
           end,

   reboot = function (htmlEnv)
              os.execute("reboot")
              return true, "rebooting....."
           end,
}


-- Entry point for call from web
function getHTML(htmlEnv)
   if _L[htmlEnv.data.subcmd]  then
      local res, a,b,c,d = pcall((_L[htmlEnv.data.subcmd]),htmlEnv)
      htmlEnv.data.mode = 'html'
      return a,b,c,d
   else
      --io.write( "Can`t find function `"..htmlEnv.data.subcmd.."` in module `configurations`.")
      return nil, "Can`t find function `"..htmlEnv.data.subcmd.."` in module `configurations`."
   end

end