module(..., package.seeall)
local s = require'scheme'
local usb = require'nsgusbconf'
local eth = require'nsgethconf'

-- priority
local ETH703PHYCLOCKPRIO      = 20
local ETH703PHYRLOOPPRIO      = 10
--

eth703Scheme = eth.ethScheme{
   _Z = function(path, sch, conf)
	   local conf = s.addDefault(path, sch, conf, true) --clone conf with defaults
	   usb.probeUSBDeviceScheme(nil, path)
	   local dev = usb.port2netdev[path[#path]]
	   if dev and conf.phy then
	      os.execute("nsgusbcfg " .. dev .. (conf.phy["rloop"] and " -rloop" or " -norloop"))
	      os.execute("nsgusbcfg " .. dev .. " -" .. conf.phy["clock"] .."clock")
	   end
	   return eth.ethScheme._Z(path, sch, conf)
	end,
   phy = s.newScheme{
      _H = "eth703Phy",

      ["clock"] = s.newScheme{
	 _H = "eth703PhyClock",
	 _T = "choice",
	 _A = {"ext", "int", },
	 _V = s.choiceVal,
	 _D = "ext",
	 _P = ETH703PHYCLOCKPRIO,
      },

      ["rloop"] = function(_, path)
         local dev = usb.FindDevice(path[#path - 2])
         local vidpid = dev and dev.vidpid or ""
         if vidpid == "0483/fff7" then
            return s.booleanType{
               _H = "eth703PhyRloop",
               _D = false,
               _P = ETH703PHYRLOOPPRIO,
            }
         end
      end,
   },
}
