module(..., package.seeall)
local s = require'scheme'

local restartEndpoint =
   function(path, sch, conf, prevConf)
      local confFile="/tmp/endpoint.ini"
      if not s.confCmp(conf, prevConf) then
         conf = conf or {}
         local cfg = {}
         local cmd
         conf = s.addDefault(path, sch, conf, true)

         if conf["adm-state"]=="up" then
            cfg[#cfg + 1] = ";This is autogenerated config file, written by nsgconfd."
            for k,v in pairs(conf or {}) do
               if (k~="adm-state") and (k~="show") then
                  cfg[#cfg + 1] = k:gsub("-","_"):upper().." "..v
               end
            end
            local f = io.open(confFile,"w")
            if f then
               f:write(table.concat(cfg,"\n").."\n")
               f:close()
            end
            cmd = {}
            cmd[#cmd + 1] = "/opt/Ixia/endpoint"
            cmd[#cmd + 1] = "-n"
         else
            os.execute('rm -f '..confFile)
         end
         C.restartDaemon(path,
                         cmd,
                         {
                            noRestart = false,
                            atExit = C.increasingSleep,
                         }
                      )
         return true
      else
         return true
      end
   end

endpointScheme =
   function()
      return os.execute("[ -f /opt/Ixia/endpoint ]")==0 and s.newScheme{
      _H = "Endpoint",
      _Z = restartEndpoint,
      ["show"]= s.newScheme{
         _P = -10,
         _H = "EndpointShow",
         ["log"] =  s.newScheme{
            _H = "EndpointShowLog",
            _X = function(path)
                    path = s.clonePath(path, -2)
                    return C.getDaemonLog(path)
                 end,
         },
         ["configuration"] =  s.newScheme{
            _H = "EndpointShowConfig",
            _X = function(path)
                    return s.readpopen("cat /tmp/endpoint.ini 2>&1")
                 end,
         },
      },
      ["adm-state"] = s.choiceType{
         _A = {"up", "down"},
         _H = "EndpointAdmstate",
         _D = "up",
         _P = 90,
         _DEP = 3,
      },
      ["management-port"] = s.integerType{
         _H = "EndpointManagementport",
         _A = {1,65535},
         _D = 10115,
      },
      ["initial-management-tos"]  = s.integerType{
         _H = "EndpointManagementtos",
         _A = {0,255},
         _D = 0,
      },

      ["force-clocksync"] = s.integerType{
         _H = "EndpointForceclocksync",
         _A = {0,1},
         _D = 0,
      },
      ["use-encryption"]= s.choiceType{
         _A = {"on", "off"},
         _H = "EndpointUseencryption",
         _D = "off",
      },
      ["disable-discovery"]= s.choiceType{
         _A = {"on", "off"},
         _H = "EndpointDisablediscovery",
         _D = "off",
      },
      ["discovery-server-address"] = s.stringType{
         _H = "EndpointDiscoveryserveraddress",
         _D = "IxDiscoveryServ"
      },
      ["discovery-server-port"] = s.integerType{
         _H = "EndpointDiscoveryserverport",
         _A = {1,65535},
         _D = 10120,
      },
      ["discovery-interval-between-connects"] = s.integerType{
         _H = "EndpointDiscoveryintervalbetweenconnects",
         _A = {0,2000000},
         _D = 0,
      },
      ["reporting-timeout"] = s.integerType{
         _H = "EndpointReportingtimeout",
         _A = {0,999999},
         _D = 0,
      },
   }
end