module(..., package.seeall)
local s = require'scheme'
local eth = require'nsgethconf'
local ppp = require'nsgpppconf'
local usb = require'nsgusbconf'

local function restartLTE(path, sch, conf, prevConf)
   local conf = s.addDefault(path, sch, conf, true)
   
   if conf["adm-state"] == 'down'then
      C.restartDaemon(path)
      return true
   end

   local dev = usb.port2netdev[path[#path]]
   local TTY = usb.port2tty[path[#path]]
   local chatcmd = "chat -e -t 10 1>" .. TTY .. " <" .. TTY 
   
   local ss_SW = ' XXX-AT-OK AT+COPS=1,2,25002,7 OK AT!SCACT=1,1 OK ""'
   local ss_AT = ' XXX-AT-OK AT+CFUN=1 OK AT!CGATT=1 OK ""'
   local cs = ' "" AT+CSQ OK AT+CGREG? OK AT+COPS? OK ""'
   local device = usb.FindDevice(path[#path])
   local ss = (device.vidpid == "216f/0041") and ss_AT or ss_SW

   if dev and (dev ~= '') then
      local start = chatcmd .. ss
      local check = chatcmd .. cs
      local cmdString = {"su", "-c", start.."; while true; do echo LTE-works; "..check.."; sleep 3; done"}
      C.restartDaemon(path, cmdString, {atExit = C.increasingSleep, })
   else
      print("*** Error: NO DEVICE ***") --- TODO replace to log:write
   end
   
   return true
end
----------------------------------------

LTEScheme = eth.ethScheme{
   _Z = function(path, sch, conf) 
	   usb.probeUSBDeviceScheme(nil, path)
	   eth.ethScheme._Z(path, sch, conf)
           return restartLTE(path, sch, conf)
	end,

   link = function()  return false  end,
   vlan = function()  return false  end,
   vrrp = function()  return false  end,
   
   ["raw-access"] = function()
		       return ppp.rawAccessScheme
		    end,
   
   ["log"] =  s.newScheme{
      _H = "LTELog",
      _X = function(path)
	      local path = s.clonePath(path, -1)
	      return C.getDaemonLog(path)
	   end,
      _R = 'user',
   },  
}
